--^=========================================^--
--)-----[ AW's TAIWANESE REPUBLIC MOD ]-----(--
--V=========================================V--
-->-------> DECISIONS COMPATIBILITY <-------<--

function GetMajorPlayersWithTech(iTech)
	local tPlayers = {}
	for i = 0, GameDefines.MAX_MAJOR_CIVS - 1, 1 do
		pPlayer = Players[i]
		if (Teams[pPlayer:GetTeam()]:IsHasTech(iTech)) then
			table.insert(tPlayers, pPlayer)
		end
	end
	return tPlayers
end

function LargestCity(pPlayer)
	local iLargestPop = 0;
	local pLargestCity
	for pCity in pPlayer:Cities() do
		local iPop = pCity:GetPopulation()
		if (iPop > iLargestPop) then
			iLargestPop = iPop
			pLargestCity = pCity
		end
	end
	return pLargestCity
end

-----------------------------------------------
------[ TEN MAJOR CONSTRUCTION PROJECTS ]------
-----------------------------------------------
-- With the world currently in a global economic crisis, we have a golden opportunity to leap ahead of our competitors and secure a brighter future.
-- Our infrastructure could use some improvement. Why not embark on an overhaul of out domestic industry?
-- Requirements, 

local Decision_AW_Taiwan_10MajorConstructionProjects = {}
	Decision_AW_Taiwan_10MajorConstructionProjects.Name = "TXT_KEY_DECISION_AW_TAIWAN_10_MAJOR_CONSTRUCTION_PROJECTS"
	Decision_AW_Taiwan_10MajorConstructionProjects.Desc = "TXT_KEY_DECISION_AW_TAIWAN_10_MAJOR_CONSTRUCTION_PROJECTS_DESC"
	HookDecisionCivilizationIcon(Decision_AW_Taiwan_10MajorConstructionProjects, "CIVILIZATION_AW_TAIWAN")
	Decision_AW_Taiwan_10MajorConstructionProjects.CanFunc = (
	function(pPlayer)
		if (pPlayer:GetCivilizationType() ~= GameInfoTypes.CIVILIZATION_AW_TAIWAN) then return false, false end
		if (load(pPlayer, "Decision_AW_Taiwan_10MajorConstructionProjects") == true) then
			Decision_AW_Taiwan_10MajorConstructionProjects.Desc = Locale.ConvertTextKey("TXT_KEY_DECISION_AW_TAIWAN_10_MAJOR_CONSTRUCTION_PROJECTS_DESC_ENACTED")
			--	The max text string length for Civ5:									"________________________________________________________________________________________________________________________________"
			return false, false, true
		end
		local iCost = math.ceil(2*iMod*pPlayer:GetTotalLand())
		Decision_AW_Taiwan_10MajorConstructionProjects.Desc = Locale.ConvertTextKey("TXT_KEY_DECISION_AW_TAIWAN_10_MAJOR_CONSTRUCTION_PROJECTS_DESC", iCost)
		if (pPlayer:GetNumResourceAvailable(iMagistrate, false) < 1) then return true, false end
		if (pPlayer:GetGold() < iCost) then return true, false end
		if (pPlayer:GetCurrentEra() < GameInfoTypes.ERA_MODERN) then return true, false end
		if (pPlayer:GetCapitalCity() == nil) then return true, false end
		return true, true
	end
	)
	Decision_AW_Taiwan_10MajorConstructionProjects.DoFunc = (
	function(pPlayer)
		local iCost = math.ceil(2*iMod*pPlayer:GetTotalLand())
		pPlayer:ChangeGold(-iCost)
		pPlayer:ChangeNumResourceTotal(iMagistrate, -1)
		pPlayer:SetNumFreePolicies(1)
		pPlayer:SetNumFreePolicies(0)
		pPlayer:SetHasPolicy(GameInfoTypes.POLICY_AW_TAIWAN_10_MAJOR_CONSTRUCTION_PROJECTS, true)
		save(pPlayer, "Decision_AW_Taiwan_10MajorConstructionProjects", true)
	end
	)
Decisions_AddCivilisationSpecific(GameInfoTypes.CIVILIZATION_AW_TAIWAN, "Decision_AW_Taiwan_10MajorConstructionProjects", Decision_AW_Taiwan_10MajorConstructionProjects)

-----------------------------------------------
----------[ HOLD THE COMPUTEX TAIPEI ]---------
-----------------------------------------------
-- The future will belong to whoever can take the lead in high-tech industries. In our age, computers are at the forefront of those industries.
-- We would do well to expand our market share of the global electronics industry - and perhaps "adopt" some of our competitors' secrets as well.

Decisions_AW_Taiwan_ComputexTaipei = {}
	Decisions_AW_Taiwan_ComputexTaipei.Name = "TXT_KEY_DECISION_AW_TAIWAN_COMPUTEX_TAIPEI"
	Decisions_AW_Taiwan_ComputexTaipei.Desc = "TXT_KEY_DECISION_AW_TAIWAN_COMPUTEX_TAIPEI_DESC"
	HookDecisionCivilizationIcon(Decisions_AW_Taiwan_ComputexTaipei, "CIVILIZATION_AW_TAIWAN")
	Decisions_AW_Taiwan_ComputexTaipei.CanFunc = (
		function(pPlayer)
			if (pPlayer:GetCivilizationType() ~= GameInfoTypes.CIVILIZATION_AW_TAIWAN) then return false, false end
			
			local iEra = load(pPlayer, "Decisions_AW_Taiwan_ComputexTaipei")
			local iCurrentEra = pPlayer:GetCurrentEra()
			if iEra ~= nil then
				if iEra < iCurrentEra then
					save(pPlayer, "Decisions_AW_Taiwan_ComputexTaipei", nil)
				else
					Decisions_AW_Taiwan_ComputexTaipei.Desc = Locale.ConvertTextKey("TXT_KEY_DECISION_AW_TAIWAN_COMPUTEX_TAIPEI_DESC_ENACTED")
					return false, false, true
				end
			end

			local tComputerCivs = GetMajorPlayersWithTech(GameInfoTypes.TECH_COMPUTERS)
			
			tToRemove = {}
			for k, player in pairs(tComputerCivs) do
				if (player:GetID() == pPlayer:GetID()) then
					tToRemove[k] = player
				end
			end
			for k, _ in pairs(tToRemove) do
				tComputerCivs[k] = nil;
			end

			local iComputerCivs = #tComputerCivs
			local iTotalScience = 0;
			for _, computerPlayer in pairs(tComputerCivs) do
				iTotalScience = iTotalScience + computerPlayer:GetScience()
			end
			local iCost = math.ceil(100*iComputerCivs*iMod)
			local iCost2 = math.ceil(math.sqrt(iCost))
			local iScienceToGive = math.ceil( 0.5 * iTotalScience )
			Decisions_AW_Taiwan_ComputexTaipei.Desc = Locale.ConvertTextKey("TXT_KEY_DECISION_AW_TAIWAN_COMPUTEX_TAIPEI_DESC", iCost, iCost2, iScienceToGive, iComputerCivs)
			if (iComputerCivs < 1) then return true, false end
			if not (Teams[pPlayer:GetTeam()]:IsHasTech(GameInfoTypes.TECH_COMPUTERS)) then return true, false end
			if (pPlayer:GetNumResourceAvailable(iMagistrate, false) < 1) then return true, false end
			if (pPlayer:GetGold() < iCost) then	return true, false end
			if (pPlayer:GetJONSCulture() < iCost2) then return true, false end
			if (pPlayer:GetCapitalCity() == nil) then return true, false end

			return true, true
		end
	)	
	Decisions_AW_Taiwan_ComputexTaipei.DoFunc = (
	function(pPlayer)
		local tComputerCivs = GetMajorPlayersWithTech(GameInfoTypes.TECH_COMPUTERS)
			
		tToRemove = {}
		for k, player in pairs(tComputerCivs) do
			if (player:GetID() == pPlayer:GetID()) then
				tToRemove[k] = player
			end
		end
		for k, _ in pairs(tToRemove) do
			tComputerCivs[k] = nil;
		end

		local iComputerCivs = #tComputerCivs
		local iTotalScience = 0;
		for _, computerPlayer in pairs(tComputerCivs) do
			iTotalScience = iTotalScience + computerPlayer:GetScience()
		end
		local iScienceToGive = math.ceil( 0.5 * iTotalScience )
		local iCost = math.ceil(100*iComputerCivs*iMod)
		local iCost2 = math.ceil(math.sqrt(iCost))
		pPlayer:ChangeGold(-iCost)
		pPlayer:ChangeJONSCulture(-iCost2)
		LargestCity(pPlayer):ChangeResistanceTurns(1)
		Teams[pPlayer:GetTeam()]:GetTeamTechs():ChangeResearchProgress(pPlayer:GetCurrentResearch(), iScienceToGive, pPlayer:GetID())
		save(pPlayer, "Decisions_AW_Taiwan_ComputexTaipei", pPlayer:GetCurrentEra())
	end
	)
Decisions_AddCivilisationSpecific(GameInfoTypes.CIVILIZATION_AW_TAIWAN, "Decisions_AW_Taiwan_ComputexTaipei", Decisions_AW_Taiwan_ComputexTaipei)