--^=========================================^--
--)-----[ AW's TAIWANESE REPUBLIC MOD ]-----(--
--V=========================================V--
-->---------> EVENTS COMPATIBILITY <--------<--

include("AW_Math_Functions.lua")

-----------------------------------------------
-------------[ UTILITY FUNCTIONS ]-------------
-----------------------------------------------

-- Credit to JFD for this function
function SendWorldEvent(description)
	Players[Game.GetActivePlayer()]:AddNotification(NotificationTypes["NOTIFICATION_DIPLOMACY_DECLARATION"], description, "[COLOR_POSITIVE_TEXT]World Events[ENDCOLOR]", -1, -1)
end    
-- And also this one
function GetRandom(lower, upper)
    return Game.Rand((upper + 1) - lower, "") + lower
end
-- This one is just an extension of SendWorldEvent
function SendWorldEventIfMet(pPlayer, sEvent)
	if not pPlayer:IsHuman() and Teams[pPlayer:GetTeam()]:IsHasMet(Players[Game.GetActivePlayer()]:GetTeam()) then
		SendWorldEvent(Locale.ConvertTextKey(sEvent)) 
	end
end

function GetWorstEnemy(pPlayer)
	local bFoundWorstEnemy = false;
	local pWorstEnemy
	local sWorstEnemy = pPlayer.GetWorstEnemyName()
	for i = 0, GameDefines.MAX_MAJOR_CIVS - 1, 1 do
		local mPlayer = Players[i]
		if (mPlayer ~= nil) then
			if (mPlayer:IsAlive()) then
				if (mPlayer:GetName() == sWorstEnemy) then
					bFoundWorstEnemy = true;
					pWorstEnemy = mPlayer
					break
				end
			end
		end
	end
end

function LargestCity(pPlayer)
	local iLargestPop = 0;
	local pLargestCity
	for pCity in pPlayer:Cities() do
		local iPop = pCity:GetPopulation()
		if (iPop > iLargestPop) then
			iLargestPop = iPop
			pLargestCity = pCity
		end
	end
	return pLargestCity
end

-----------------------------------------------
----------[ GOOD: THE MA-XI MEETING ]----------
-----------------------------------------------
-- We have the rare opportunity to hold a diplomatic meeting with {1_Leader}, with whom we have historically engaged in hostilities. We've previously promised the populace
-- that we would never meet with our sworn enemy, but on the other hand, this may be the beginning of closer bond between our empires and help to thaw our icy relations.
-- 1) "I'll even shake his/her hand!" - Free research agreement, Capital goes into resistance for one turn
-- 2) "I will not betray my people!" - WLTKD in the capital, also in other cities but for fewer turns

local Event_AW_Taiwan_MaXiMeeting = {}
	Event_AW_Taiwan_MaXiMeeting.Name = "TXT_KEY_EVENT_AW_TAIWAN_MA_XI_MEETING"
	Event_AW_Taiwan_MaXiMeeting.Desc = "TXT_KEY_EVENT_AW_TAIWAN_MA_XI_MEETING_DESC"
	Event_AW_Taiwan_MaXiMeeting.Weight = 25
	Event_AW_Taiwan_MaXiMeeting.CanFunc = (
		function(pPlayer)
			if (load(pPlayer, "Event_AW_Taiwan_MaXiMeeting") == true) then return false end
			if (pPlayer:GetCivilizationType() ~= GameInfoTypes.CIVILIZATION_AW_TAIWAN) then return false end
			if (pPlayer:GetCurrentEra() > GameInfoTypes.ERA_MODERN) then return false end
	
			local pWorstEnemy = GetWorstEnemy(pPlayer)
			if (pWorstEnemy == nil) then return false end -- I'm not sure what happened here, but it's best not to push it
						
			
			sLeader = Locale.ConvertTextKey(GameInfo.Leaders[pPlayer:GetLeaderType()].Description)
			Event_AW_Taiwan_MaXiMeeting.Desc = Locale.ConvertTextKey("TXT_KEY_EVENT_AW_TAIWAN_MA_XI_MEETING_DESC", sLeader)

			return true
		end
	)
	Event_AW_Taiwan_MaXiMeeting.Outcomes = {}
-->--------------> OUTCOME 1 <--------------<--
-- 1) "I'll even shake his/her hand!" - Free research agreement, Capital goes into resistance for one turn
	Event_AW_Taiwan_MaXiMeeting.Outcomes[1] = {}
		Event_AW_Taiwan_MaXiMeeting.Outcomes[1].Name = "TXT_KEY_EVENT_AW_TAIWAN_MA_XI_MEETING_OUTCOME_1"
		Event_AW_Taiwan_MaXiMeeting.Outcomes[1].Desc = "TXT_KEY_EVENT_AW_TAIWAN_MA_XI_MEETING_OUTCOME_1_DESC"
		Event_AW_Taiwan_MaXiMeeting.Outcomes[1].CanFunc = (
			function(pPlayer)
				Event_AW_Taiwan_MaXiMeeting.Outcomes[1].Desc = Locale.ConvertTextKey("TXT_KEY_EVENT_AW_TAIWAN_MA_XI_MEETING_OUTCOME_1_DESC")
				return true
			end
		)
		Event_AW_Taiwan_MaXiMeeting.Outcomes[1].DoFunc = (
			function(pPlayer)
				local iTarget = GetWorstEnemy(pPlayer):GetID()
				local deal = UI.GetScratchDeal()
				deal:SetFromPlayer(iTarget)
				deal:SetToPlayer(pPlayer:GetID())
				deal:AddResearchAgreement(iTarget, iDuration)
				deal:AddResearchAgreement(iPlayer, iDuration)
				UI.DoFinalizePlayerDeal(iTarget, iPlayer, true)
				pPlayer:GetCapitalCity():ChangeResistanceTurns(1)
				SendWorldEventIfMet(pPlayer, "TXT_KEY_WORLD_EVENT_AW_TAIWAN_MA_XI_MEETING_OUTCOME_1")
				save(pPlayer, "Event_AW_Taiwan_MaXiMeeting", true)
			end
		)
-->--------------> OUTCOME 2 <--------------<--
-- 2) "I will not betray my people!" - WLTKD in the capital, also in other cities but for fewer turns
	Event_AW_Taiwan_MaXiMeeting.Outcomes[2] = {}
		Event_AW_Taiwan_MaXiMeeting.Outcomes[2].Name = "TXT_KEY_EVENT_AW_TAIWAN_MA_XI_MEETING_OUTCOME_2"
		Event_AW_Taiwan_MaXiMeeting.Outcomes[2].Desc = "TXT_KEY_EVENT_AW_TAIWAN_MA_XI_MEETING_OUTCOME_2_DESC"
		Event_AW_Taiwan_MaXiMeeting.Outcomes[2].CanFunc = (
			function(pPlayer)
				Event_AW_Taiwan_MaXiMeeting.Outcomes[2].Desc = Locale.ConvertTextKey("TXT_KEY_EVENT_AW_TAIWAN_MA_XI_MEETING_OUTCOME_2_DESC")
				return true
			end
		)
		Event_AW_Taiwan_MaXiMeeting.Outcomes[2].DoFunc = (
			function(pPlayer)
				local iTotalWLTKDTurns = 10 * pPlayer:GetNumCities()
				for pCity in pPlayer:Cities() do
					if (iTotalWLTKDTurns > 0) then
						pCity:ChangeWeLoveTheKingDayCounter(GetRandom(1, iTotalWLTKDTurns))
					else
						break
					end
				end
				SendWorldEventIfMet(pPlayer, "TXT_KEY_WORLD_EVENT_AW_TAIWAN_MA_XI_MEETING_OUTCOME_2")
				save(pPlayer, "Event_AW_Taiwan_MaXiMeeting", true)
			end
		)

Events_AddCivilisationSpecific(GameInfoTypes.CIVILIZATION_AW_TAIWAN, "Event_AW_Taiwan_MaXiMeeting", Event_AW_Taiwan_MaXiMeeting)

-----------------------------------------------
---------[ BAD: FEBRUARY 28 INCIDENT ]---------
-----------------------------------------------
-- Mayhem! Uprisings! After a reckless drug enforcement agent bludgeoned a tobacco dealer, a riot ensued in our capital, which was crushed with horrifyingly
-- lethal brutality by the police. How shall we respond to the mass protests erupting across the whole nation in response?
-- 1) Supress these revolts with every weapon in the arsenal! - less anarchy and damage, but also unhappiness
-- 2) Stall for time. Maybe the problem will fix itself... - anarchy and damage to all cities
-- 3) Offer our condolences - and compensation - to the bereaved. - Minimal anarchy in the capital and lose gold

local Event_AW_Taiwan_February28 = {}
	Event_AW_Taiwan_February28.Name = "TXT_KEY_EVENT_AW_TAIWAN_FEBRUARY_28"
	Event_AW_Taiwan_February28.Desc = "TXT_KEY_EVENT_AW_TAIWAN_FEBRUARY_28_DESC"
	Event_AW_Taiwan_February28.Weight = 15
	Event_AW_Taiwan_February28.CanFunc = (
		function(pPlayer)
			if (load(pPlayer, "Event_AW_Taiwan_February28") == true) then return false end
			if not (pPlayer:GetCivilizationType() == GameInfoTypes.CIVILIZATION_AW_TAIWAN) then return false end
			if (pPlayer:GetCurrentEra() > GameInfoTypes.ERA_MODERN) then return false end
			Event_AW_Taiwan_February28.Desc = Locale.ConvertTextKey("TXT_KEY_EVENT_AW_TAIWAN_FEBRUARY_28_DESC")
			return true
		end
	)
	Event_AW_Taiwan_February28.Outcomes = {}
-->--------------> OUTCOME 1 <--------------<--
-- 1) Supress these revolts with every weapon in the arsenal! - less anarchy and damage, but also unhappiness
	Event_AW_Taiwan_February28.Outcomes[1] = {}
		Event_AW_Taiwan_February28.Outcomes[1].Name = "TXT_KEY_EVENT_AW_TAIWAN_FEBRUARY_28_OUTCOME_1"
		Event_AW_Taiwan_February28.Outcomes[1].Desc = "TXT_KEY_EVENT_AW_TAIWAN_FEBRUARY_28_OUTCOME_1_DESC"
		Event_AW_Taiwan_February28.Outcomes[1].CanFunc = (
			function(pPlayer)
				Event_AW_Taiwan_February28.Outcomes[1].Desc = Locale.ConvertTextKey("TXT_KEY_EVENT_AW_TAIWAN_FEBRUARY_28_OUTCOME_1_DESC", pPlayer:GetNumCities())
				return true
			end
		)
		Event_AW_Taiwan_February28.Outcomes[1].DoFunc = (
			function(pPlayer)
				for pCity in pPlayer:Cities() do
					pCity:ChangeDamage(GetRandom(10,25))
					pCity:ChangeResistanceTurns(GetRandom(1,3))
				end
				for i, bit in pairs(bitConv(pPlayer:GetNumCities())) do
					pPlayer:SetHasPolicy(GameInfoTypes["POLICY_AW_TAIWAN_FEBRUARY_28_"..tostring(bit)], true)
				end
				SendWorldEventIfMet(pPlayer, "TXT_KEY_WORLD_EVENT_AW_TAIWAN_FEBRUARY_28_OUTCOME_1")
				save(pPlayer, "Event_AW_Taiwan_February28", true)
				save(pPlayer, "Event_AW_Taiwan_February28_UnhappinessIC", {Game.GetGameTurn(), pPlayer:GetNumCities()})
				GameEvents.PlayerDoTurn.Add(Event_AW_Taiwan_February28_NaturalDecrease)
			end
		)
-->--------------> OUTCOME 2 <--------------<--
-- 2) Stall for time. Maybe the problem will fix itself... - anarchy and damage to all cities
	Event_AW_Taiwan_February28.Outcomes[2] = {}
		Event_AW_Taiwan_February28.Outcomes[2].Name = "TXT_KEY_EVENT_AW_TAIWAN_FEBRUARY_28_OUTCOME_2"
		Event_AW_Taiwan_February28.Outcomes[2].Desc = "TXT_KEY_EVENT_AW_TAIWAN_FEBRUARY_28_OUTCOME_2_DESC"
		Event_AW_Taiwan_February28.Outcomes[2].CanFunc = (
			function(pPlayer)
				Event_AW_Taiwan_February28.Outcomes[2].Desc = Locale.ConvertTextKey("TXT_KEY_EVENT_AW_TAIWAN_FEBRUARY_28_OUTCOME_2_DESC")
				return true
			end
		)
		Event_AW_Taiwan_February28.Outcomes[2].DoFunc = (
			function(pPlayer)
				for pCity in pPlayer:Cities() do
					pCity:ChangeDamage(GetRandom(25,50))
					pCity:ChangeResistanceTurns(GetRandom(3,5))
				end
				SendWorldEventIfMet(pPlayer, "TXT_KEY_WORLD_EVENT_AW_TAIWAN_FEBRUARY_28_OUTCOME_2")
				save(pPlayer, "Event_AW_Taiwan_February28", true)
			end
		)
-->--------------> OUTCOME 3 <--------------<--
-- 3) Offer our condolences - and compensation - to the bereaved. - Minimal anarchy in the capital and lose gold
	Event_AW_Taiwan_February28.Outcomes[3] = {}
		Event_AW_Taiwan_February28.Outcomes[3].Name = "TXT_KEY_EVENT_AW_TAIWAN_FEBRUARY_28_OUTCOME_3"
		Event_AW_Taiwan_February28.Outcomes[3].Desc = "TXT_KEY_EVENT_AW_TAIWAN_FEBRUARY_28_OUTCOME_3_DESC"
		Event_AW_Taiwan_February28.Outcomes[3].CanFunc = (
			function(pPlayer)
				local iCost = LargestCity(pPlayer):GetPopulation() * pCity:GetNumCities()
				Event_AW_Taiwan_February28.Outcomes[3].Desc = Locale.ConvertTextKey("TXT_KEY_EVENT_AW_TAIWAN_FEBRUARY_28_OUTCOME_3_DESC", iCost)
				if (pPlayer:GetGold() < iCost) then return false end
				return true
			end
		)
		Event_AW_Taiwan_February28.Outcomes[3].DoFunc = (
			function(pPlayer)
				local iCost = LargestCity(pPlayer):GetPopulation() * pCity:GetNumCities()
				pPlayer:ChangeGold(-iCost)
				for pCity in pPlayer:Cities() do
					pCity:ChangeDamage(GetRandom(5,20))
					pCity:ChangeResistanceTurns(GetRandom(0,2))
				end
			end
		)
Events_AddCivilisationSpecific(GameInfoTypes.CIVILIZATION_AW_TAIWAN, "Event_AW_Taiwan_February28", Event_AW_Taiwan_February28)

function Event_AW_Taiwan_February28_NaturalDecrease(iPlayer)
	local pPlayer = Players[iPlayer]
	local initialConditions = load(pPlayer, Event_AW_Taiwan_February28_UnhappinessIC)
	if (initialConditions == nil) then return end
	local dT = 40; -- delta-t: change in time (number of turns before unhappiness completely subsides)
	local Ti = initialConditions[1] -- t-initial: game turn when this all started
	local Tf = Ti + dT -- t-final: final game turn
	local iGameTurn = Game.GetGameTurn()
	if (iGameTurn >= Tf + 1) then
	--	GameEvents.PlayerDoTurn.Remove(Event_AW_Taiwan_February28_NaturalDecrease)
		return
	end
	local Te = Ti + iGameTurn -- elapsed turns since t-initial
	local dY = initialConditions[2] -- delta-Y: change in height (total unhappiness to eventually subside)
	local iNewUnhappiness = math.ceil( (dY/2)*math.cos( ((2*math.pi)/(2*dT)) * Te ) + (dY/2) ) --[[
	I'm using half of a period of a cosine wave to model a natural decrease in unhappiness:
	Go to https://www.desmos.com/calculator and graph:

	          /  2pi    \
	Y = 5 cos | ----- X |  + 5
			  \   80    /

	And focus on the part of the cosine wave from x = 0 to x = 40.
	That part is what we're modelling above: at x = 0, unhappiness is at it's max,
	and it gradually decreases to 0 by x = 40.

	The above equation assumes the following initial conditions:
	1) At the time of enacting, # cities = 10
	2) We want the unhappiness to completely subside over 40 turns.

	Generalized, the equation we want to model looks like this:

	     max height        /          2pi         \	  max height 
	Y = ------------ * cos | -------------------- |  + ------------
	          2            \   2 * time until 0   /	       2     

	Where the max height is the beginning unhappiness. And since we've coded
	for beginning unhappiness to be equal to the number of the number of cities
	at the time of enacting, if you have 10 cities, max height = 10, and so the
	coefficient at the start is 10/2 = 5. ]]--
	for _, bit in pairs({1,2,4,8,16,32,64,128}) do
		pPlayer:SetHasPolicy(GameInfoTypes["POLICY_AW_TAIWAN_FEBRUARY_28_"..tostring(bit)], false)
	end
	for i, bit in pairs(bitConv(iNewUnhappiness)) do
		pPlayer:SetHasPolicy(GameInfoTypes["POLICY_AW_TAIWAN_FEBRUARY_28_"..tostring(bit)], true)
	end
end